import { useConfig } from '@kevisual/use-config/env';
import { Sequelize } from 'sequelize';
import { useContextKey } from '@kevisual/use-config/context';

const configEnv = useConfig();

const postgresConfig = {
  username: configEnv.POSTGRES_USERNAME,
  password: configEnv.POSTGRES_PASSWORD,
  host: configEnv.POSTGRES_HOST,
  port: configEnv.POSTGRES_PORT ? parseInt(configEnv.POSTGRES_PORT) : 5432,
  database: configEnv.POSTGRES_DATABASE,
};

if (!postgresConfig) {
  console.error('postgres config is required');
  process.exit(1);
}
// connect to db
export const init = () => {
  return new Sequelize({
    dialect: 'postgres',
    ...postgresConfig,
    // logging: false,
  });
};
export const sequelize = useContextKey('sequelize', init);
